/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// identities - Array of identities in sip uri format.    inboundMessagesSubscriptions - InboundMessagesSubscriptions parameter block.    outboundMessagesSubscriptions - OutboundMessagesSubscriptions parameter block.
    /// </summary>
    [DataContract]
        public partial class MessagesSubscribeParams :  IEquatable<MessagesSubscribeParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MessagesSubscribeParams" /> class.
        /// </summary>
        /// <param name="identities">identities.</param>
        /// <param name="inboundMessagesSubscriptions">inboundMessagesSubscriptions.</param>
        /// <param name="outboundMessagesSubscriptions">outboundMessagesSubscriptions.</param>
        public MessagesSubscribeParams(List<string> identities = default(List<string>), InboundMessagesSubscriptions inboundMessagesSubscriptions = default(InboundMessagesSubscriptions), OutboundMessagesSubscriptions outboundMessagesSubscriptions = default(OutboundMessagesSubscriptions))
        {
            this.Identities = identities;
            this.InboundMessagesSubscriptions = inboundMessagesSubscriptions;
            this.OutboundMessagesSubscriptions = outboundMessagesSubscriptions;
        }
        
        /// <summary>
        /// Gets or Sets Identities
        /// </summary>
        [DataMember(Name="identities", EmitDefaultValue=false)]
        public List<string> Identities { get; set; }

        /// <summary>
        /// Gets or Sets InboundMessagesSubscriptions
        /// </summary>
        [DataMember(Name="inboundMessagesSubscriptions", EmitDefaultValue=false)]
        public InboundMessagesSubscriptions InboundMessagesSubscriptions { get; set; }

        /// <summary>
        /// Gets or Sets OutboundMessagesSubscriptions
        /// </summary>
        [DataMember(Name="outboundMessagesSubscriptions", EmitDefaultValue=false)]
        public OutboundMessagesSubscriptions OutboundMessagesSubscriptions { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class MessagesSubscribeParams {\n");
            sb.Append("  Identities: ").Append(Identities).Append("\n");
            sb.Append("  InboundMessagesSubscriptions: ").Append(InboundMessagesSubscriptions).Append("\n");
            sb.Append("  OutboundMessagesSubscriptions: ").Append(OutboundMessagesSubscriptions).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as MessagesSubscribeParams);
        }

        /// <summary>
        /// Returns true if MessagesSubscribeParams instances are equal
        /// </summary>
        /// <param name="input">Instance of MessagesSubscribeParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(MessagesSubscribeParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Identities == input.Identities ||
                    this.Identities != null &&
                    input.Identities != null &&
                    this.Identities.SequenceEqual(input.Identities)
                ) && 
                (
                    this.InboundMessagesSubscriptions == input.InboundMessagesSubscriptions ||
                    (this.InboundMessagesSubscriptions != null &&
                    this.InboundMessagesSubscriptions.Equals(input.InboundMessagesSubscriptions))
                ) && 
                (
                    this.OutboundMessagesSubscriptions == input.OutboundMessagesSubscriptions ||
                    (this.OutboundMessagesSubscriptions != null &&
                    this.OutboundMessagesSubscriptions.Equals(input.OutboundMessagesSubscriptions))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Identities != null)
                    hashCode = hashCode * 59 + this.Identities.GetHashCode();
                if (this.InboundMessagesSubscriptions != null)
                    hashCode = hashCode * 59 + this.InboundMessagesSubscriptions.GetHashCode();
                if (this.OutboundMessagesSubscriptions != null)
                    hashCode = hashCode * 59 + this.OutboundMessagesSubscriptions.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
